---
---
<!-- HTML header for doxygen 1.8.10-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>TGUI: tgui::Theme Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<!-- BEGIN CUSTOM 1 -->
<!-- --{{""}}>
{% include head.ext %}
<style>
  div {
    margin-bottom: 0
  }
  #contents {
    padding-left: 0;
    padding-right: 0;
    margin-left: 0;
    margin-right: 0;
    max-width: 1060px;
  }
  address.footer {
    padding-bottom: 1.4em;
  }
</style>
<script type="text/javascript">
function getXPos(item) {
  var x = 0;
  if (item.offsetWidth) {
    while (item && item != document.body && item.id != 'body') {
      x   += item.offsetLeft;
      item = item.offsetParent;
    }
  }
  return x;
}
</script>
<{{""}}!-- -->
<!-- END CUSTOM 1 -->
</head>
<body>
<!-- BEGIN CUSTOM 2 -->
<!-- --{{""}}>
<div id="body" class="NoMargin">
{% include navigation.ext %}
<div id="contents" class="NoMargin">
<{{""}}!-- {% raw %} -->
<!-- END CUSTOM 2 -->
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">TGUI
   &#160;<span id="projectnumber">v0.7-dev</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacetgui.html">tgui</a></li><li class="navelem"><a class="el" href="classtgui_1_1Theme.html">Theme</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classtgui_1_1Theme-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">tgui::Theme Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Default <a class="el" href="classtgui_1_1Theme.html" title="Default Theme class. ">Theme</a> class.  
 <a href="classtgui_1_1Theme.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="Theme_8hpp_source.html">Theme.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for tgui::Theme:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classtgui_1_1Theme.png" usemap="#tgui::Theme_map" alt=""/>
  <map id="tgui::Theme_map" name="tgui::Theme_map">
<area href="classtgui_1_1BaseTheme.html" title="Base class for the Theme classes. " alt="tgui::BaseTheme" shape="rect" coords="0,56,265,80"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a6428ad1bf9c7b651f42e4863a91b82bf"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6428ad1bf9c7b651f42e4863a91b82bf"></a>
typedef std::shared_ptr&lt; <a class="el" href="classtgui_1_1Theme.html">Theme</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#a6428ad1bf9c7b651f42e4863a91b82bf">Ptr</a></td></tr>
<tr class="memdesc:a6428ad1bf9c7b651f42e4863a91b82bf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Shared theme pointer. <br /></td></tr>
<tr class="separator:a6428ad1bf9c7b651f42e4863a91b82bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a030fa19678bb9f8a5844ce6b4e17c767"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#a030fa19678bb9f8a5844ce6b4e17c767">Theme</a> (const std::string &amp;filename=&quot;&quot;)</td></tr>
<tr class="memdesc:a030fa19678bb9f8a5844ce6b4e17c767"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct the theme class, with an optional theme file to load.  <a href="#a030fa19678bb9f8a5844ce6b4e17c767">More...</a><br /></td></tr>
<tr class="separator:a030fa19678bb9f8a5844ce6b4e17c767"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4f5d1531280273b1914f0f043b8dc75c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classtgui_1_1WidgetConverter.html">WidgetConverter</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#a4f5d1531280273b1914f0f043b8dc75c">load</a> (std::string className)</td></tr>
<tr class="memdesc:a4f5d1531280273b1914f0f043b8dc75c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Load the widget from the theme.  <a href="#a4f5d1531280273b1914f0f043b8dc75c">More...</a><br /></td></tr>
<tr class="separator:a4f5d1531280273b1914f0f043b8dc75c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a22dbce626a48780b9bddf239ae8fe834"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#a22dbce626a48780b9bddf239ae8fe834">reload</a> (const std::string &amp;filename)</td></tr>
<tr class="memdesc:a22dbce626a48780b9bddf239ae8fe834"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reload the theme with a different filename.  <a href="#a22dbce626a48780b9bddf239ae8fe834">More...</a><br /></td></tr>
<tr class="separator:a22dbce626a48780b9bddf239ae8fe834"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae45b316e7187975f24a02dac7753bc04"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#ae45b316e7187975f24a02dac7753bc04">reload</a> (std::string oldClassName, std::string newClassName)</td></tr>
<tr class="memdesc:ae45b316e7187975f24a02dac7753bc04"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reload all widgets that were loaded with a certain class name.  <a href="#ae45b316e7187975f24a02dac7753bc04">More...</a><br /></td></tr>
<tr class="separator:ae45b316e7187975f24a02dac7753bc04"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ace3e827ca1d7fe9bb28867dd18601f6b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#ace3e827ca1d7fe9bb28867dd18601f6b">reload</a> (<a class="el" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a> widget, std::string className)</td></tr>
<tr class="memdesc:ace3e827ca1d7fe9bb28867dd18601f6b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reload a specific widget.  <a href="#ace3e827ca1d7fe9bb28867dd18601f6b">More...</a><br /></td></tr>
<tr class="separator:ace3e827ca1d7fe9bb28867dd18601f6b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a77809152ae5a4b6adad307b43afd10ac"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#a77809152ae5a4b6adad307b43afd10ac">setProperty</a> (std::string className, const std::string &amp;property, const std::string &amp;value)</td></tr>
<tr class="memdesc:a77809152ae5a4b6adad307b43afd10ac"><td class="mdescLeft">&#160;</td><td class="mdescRight">Change a property of the renderer of all widgets that were loaded with a certain class name.  <a href="#a77809152ae5a4b6adad307b43afd10ac">More...</a><br /></td></tr>
<tr class="separator:a77809152ae5a4b6adad307b43afd10ac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a909fb7903bcf81bdd6730fabadcd521a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#a909fb7903bcf81bdd6730fabadcd521a">setProperty</a> (std::string className, const std::string &amp;property, <a class="el" href="classtgui_1_1ObjectConverter.html">ObjectConverter</a> &amp;&amp;value)</td></tr>
<tr class="memdesc:a909fb7903bcf81bdd6730fabadcd521a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Change a property of the renderer of all widgets that were loaded with a certain class name.  <a href="#a909fb7903bcf81bdd6730fabadcd521a">More...</a><br /></td></tr>
<tr class="separator:a909fb7903bcf81bdd6730fabadcd521a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab07fc1f75dc9f8f5a851059c32da5d15"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#ab07fc1f75dc9f8f5a851059c32da5d15">getProperty</a> (std::string className, std::string property) const </td></tr>
<tr class="memdesc:ab07fc1f75dc9f8f5a851059c32da5d15"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve the serialized value of a certain property of widgets that use a certain class name.  <a href="#ab07fc1f75dc9f8f5a851059c32da5d15">More...</a><br /></td></tr>
<tr class="separator:ab07fc1f75dc9f8f5a851059c32da5d15"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd29d2bc1bc90b6aaf20598c39bc1f94"><td class="memItemLeft" align="right" valign="top">std::map&lt; std::string, std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#afd29d2bc1bc90b6aaf20598c39bc1f94">getPropertyValuePairs</a> (std::string className) const </td></tr>
<tr class="memdesc:afd29d2bc1bc90b6aaf20598c39bc1f94"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a map with all properties and their values from widgets loaded with a certain class name.  <a href="#afd29d2bc1bc90b6aaf20598c39bc1f94">More...</a><br /></td></tr>
<tr class="separator:afd29d2bc1bc90b6aaf20598c39bc1f94"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adec9efd021bbd5514b0fdeec5f8ba28a"><td class="memItemLeft" align="right" valign="top">std::shared_ptr&lt; <a class="el" href="classtgui_1_1Theme.html">Theme</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#adec9efd021bbd5514b0fdeec5f8ba28a">clone</a> () const </td></tr>
<tr class="memdesc:adec9efd021bbd5514b0fdeec5f8ba28a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clone the theme without its connected widgets.  <a href="#adec9efd021bbd5514b0fdeec5f8ba28a">More...</a><br /></td></tr>
<tr class="separator:adec9efd021bbd5514b0fdeec5f8ba28a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a002af61e6bf83f0bbe6b849bcb5f4224"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#a002af61e6bf83f0bbe6b849bcb5f4224">widgetDetached</a> (<a class="el" href="classtgui_1_1Widget.html">Widget</a> *widget) override</td></tr>
<tr class="memdesc:a002af61e6bf83f0bbe6b849bcb5f4224"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function that gets called when a widget is disconnected from this theme.  <a href="#a002af61e6bf83f0bbe6b849bcb5f4224">More...</a><br /></td></tr>
<tr class="separator:a002af61e6bf83f0bbe6b849bcb5f4224"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1d7c0bd769f542fdcbf133f7358ea93"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classtgui_1_1WidgetConverter.html">WidgetConverter</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#af1d7c0bd769f542fdcbf133f7358ea93">internalLoad</a> (const std::string &amp;filename, const std::string &amp;className) override</td></tr>
<tr class="memdesc:af1d7c0bd769f542fdcbf133f7358ea93"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function can be used inside a widget to load other widgets without access to the derived theme class.  <a href="#af1d7c0bd769f542fdcbf133f7358ea93">More...</a><br /></td></tr>
<tr class="separator:af1d7c0bd769f542fdcbf133f7358ea93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0799e83b9c999ce798c5e79c847ec990"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#a0799e83b9c999ce798c5e79c847ec990">initWidget</a> (<a class="el" href="classtgui_1_1Widget.html">Widget</a> *widget, std::string filename, std::string className) override</td></tr>
<tr class="memdesc:a0799e83b9c999ce798c5e79c847ec990"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function called by the widget to finish its initialization.  <a href="#a0799e83b9c999ce798c5e79c847ec990">More...</a><br /></td></tr>
<tr class="separator:a0799e83b9c999ce798c5e79c847ec990"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classtgui_1_1BaseTheme"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classtgui_1_1BaseTheme')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classtgui_1_1BaseTheme.html">tgui::BaseTheme</a></td></tr>
<tr class="memitem:a4505ccf085cc621b14f91193897cb467 inherit pub_methods_classtgui_1_1BaseTheme"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4505ccf085cc621b14f91193897cb467"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a4505ccf085cc621b14f91193897cb467">~BaseTheme</a> ()=default</td></tr>
<tr class="memdesc:a4505ccf085cc621b14f91193897cb467 inherit pub_methods_classtgui_1_1BaseTheme"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual destructor. <br /></td></tr>
<tr class="separator:a4505ccf085cc621b14f91193897cb467 inherit pub_methods_classtgui_1_1BaseTheme"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8a6a0cd9615c073b143189a6a1a82a4e inherit pub_methods_classtgui_1_1BaseTheme"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a8a6a0cd9615c073b143189a6a1a82a4e">widgetAttached</a> (<a class="el" href="classtgui_1_1Widget.html">Widget</a> *widget)</td></tr>
<tr class="memdesc:a8a6a0cd9615c073b143189a6a1a82a4e inherit pub_methods_classtgui_1_1BaseTheme"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual function that gets called when a widget is connected to this theme.  <a href="#a8a6a0cd9615c073b143189a6a1a82a4e">More...</a><br /></td></tr>
<tr class="separator:a8a6a0cd9615c073b143189a6a1a82a4e inherit pub_methods_classtgui_1_1BaseTheme"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a69959a2b8b1dfeae06b7f256e8fa3cbf"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classtgui_1_1Theme.html#a6428ad1bf9c7b651f42e4863a91b82bf">Theme::Ptr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1Theme.html#a69959a2b8b1dfeae06b7f256e8fa3cbf">create</a> (const std::string &amp;filename=&quot;&quot;)</td></tr>
<tr class="memdesc:a69959a2b8b1dfeae06b7f256e8fa3cbf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a new theme instance.  <a href="#a69959a2b8b1dfeae06b7f256e8fa3cbf">More...</a><br /></td></tr>
<tr class="separator:a69959a2b8b1dfeae06b7f256e8fa3cbf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_static_methods_classtgui_1_1BaseTheme"><td colspan="2" onclick="javascript:toggleInherit('pub_static_methods_classtgui_1_1BaseTheme')"><img src="closed.png" alt="-"/>&#160;Static Public Member Functions inherited from <a class="el" href="classtgui_1_1BaseTheme.html">tgui::BaseTheme</a></td></tr>
<tr class="memitem:a6df0b3356afa3ef601518dbf8b8c52f2 inherit pub_static_methods_classtgui_1_1BaseTheme"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a6df0b3356afa3ef601518dbf8b8c52f2">setConstructFunction</a> (const std::string &amp;type, const std::function&lt; <a class="el" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a>()&gt; &amp;constructor)</td></tr>
<tr class="memdesc:a6df0b3356afa3ef601518dbf8b8c52f2 inherit pub_static_methods_classtgui_1_1BaseTheme"><td class="mdescLeft">&#160;</td><td class="mdescRight">Changes the construct function of a specific widget type.  <a href="#a6df0b3356afa3ef601518dbf8b8c52f2">More...</a><br /></td></tr>
<tr class="separator:a6df0b3356afa3ef601518dbf8b8c52f2 inherit pub_static_methods_classtgui_1_1BaseTheme"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7e67bae705f027d34833220bebbc520 inherit pub_static_methods_classtgui_1_1BaseTheme"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#af7e67bae705f027d34833220bebbc520">setThemeLoader</a> (const std::shared_ptr&lt; <a class="el" href="classtgui_1_1BaseThemeLoader.html">BaseThemeLoader</a> &gt; &amp;themeLoader)</td></tr>
<tr class="memdesc:af7e67bae705f027d34833220bebbc520 inherit pub_static_methods_classtgui_1_1BaseTheme"><td class="mdescLeft">&#160;</td><td class="mdescRight">Change the function that will load the widget theme data.  <a href="#af7e67bae705f027d34833220bebbc520">More...</a><br /></td></tr>
<tr class="separator:af7e67bae705f027d34833220bebbc520 inherit pub_static_methods_classtgui_1_1BaseTheme"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_static_attribs_classtgui_1_1BaseTheme"><td colspan="2" onclick="javascript:toggleInherit('pro_static_attribs_classtgui_1_1BaseTheme')"><img src="closed.png" alt="-"/>&#160;Static Protected Attributes inherited from <a class="el" href="classtgui_1_1BaseTheme.html">tgui::BaseTheme</a></td></tr>
<tr class="memitem:a11159db7392530214ecc982e9b0f55b8 inherit pro_static_attribs_classtgui_1_1BaseTheme"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a11159db7392530214ecc982e9b0f55b8"></a>
static std::map&lt; std::string, std::function&lt; <a class="el" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a>()&gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a11159db7392530214ecc982e9b0f55b8">m_constructors</a></td></tr>
<tr class="memdesc:a11159db7392530214ecc982e9b0f55b8 inherit pro_static_attribs_classtgui_1_1BaseTheme"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classtgui_1_1Widget.html" title="The parent class for every widget. ">Widget</a> creator functions. <br /></td></tr>
<tr class="separator:a11159db7392530214ecc982e9b0f55b8 inherit pro_static_attribs_classtgui_1_1BaseTheme"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d1445eda90da9bf03a9c433df10d6b6 inherit pro_static_attribs_classtgui_1_1BaseTheme"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5d1445eda90da9bf03a9c433df10d6b6"></a>
static std::shared_ptr&lt; <a class="el" href="classtgui_1_1BaseThemeLoader.html">BaseThemeLoader</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a5d1445eda90da9bf03a9c433df10d6b6">m_themeLoader</a></td></tr>
<tr class="memdesc:a5d1445eda90da9bf03a9c433df10d6b6 inherit pro_static_attribs_classtgui_1_1BaseTheme"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classtgui_1_1Theme.html" title="Default Theme class. ">Theme</a> loading functions, they read the theme file. <br /></td></tr>
<tr class="separator:a5d1445eda90da9bf03a9c433df10d6b6 inherit pro_static_attribs_classtgui_1_1BaseTheme"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Default <a class="el" href="classtgui_1_1Theme.html" title="Default Theme class. ">Theme</a> class. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a030fa19678bb9f8a5844ce6b4e17c767"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">tgui::Theme::Theme </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filename</em> = <code>&quot;&quot;</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct the theme class, with an optional theme file to load. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>Filename of the theme file</td></tr>
  </table>
  </dd>
</dl>
<dl class="section warning"><dt>Warning</dt><dd>The theme instance has to be created with std::make_shared </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="adec9efd021bbd5514b0fdeec5f8ba28a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt;<a class="el" href="classtgui_1_1Theme.html">Theme</a>&gt; tgui::Theme::clone </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Clone the theme without its connected widgets. </p>
<p>Any changes made on the returned theme will not have any impact on this theme and vice versa. </p>

</div>
</div>
<a class="anchor" id="a69959a2b8b1dfeae06b7f256e8fa3cbf"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classtgui_1_1Theme.html#a6428ad1bf9c7b651f42e4863a91b82bf">Theme::Ptr</a> tgui::Theme::create </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filename</em> = <code>&quot;&quot;</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Creates a new theme instance. </p>
<dl class="section return"><dt>Returns</dt><dd>The new theme </dd></dl>

</div>
</div>
<a class="anchor" id="ab07fc1f75dc9f8f5a851059c32da5d15"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string tgui::Theme::getProperty </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>className</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>property</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Retrieve the serialized value of a certain property of widgets that use a certain class name. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">className</td><td>The class name of the widgets </td></tr>
    <tr><td class="paramname">property</td><td>The property that you would like to retrieve</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The serialized value or an empty string when the property did not exist </dd></dl>

</div>
</div>
<a class="anchor" id="afd29d2bc1bc90b6aaf20598c39bc1f94"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::map&lt;std::string, std::string&gt; tgui::Theme::getPropertyValuePairs </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>className</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get a map with all properties and their values from widgets loaded with a certain class name. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">className</td><td>The class name of the widgets</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Serialized property-value pairs </dd></dl>

</div>
</div>
<a class="anchor" id="a0799e83b9c999ce798c5e79c847ec990"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void tgui::Theme::initWidget </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classtgui_1_1Widget.html">Widget</a> *&#160;</td>
          <td class="paramname"><em>widget</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>className</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function called by the widget to finish its initialization. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">widget</td><td>The widget that needs to be initialized </td></tr>
    <tr><td class="paramname">filename</td><td>Filename that was used to load the widget </td></tr>
    <tr><td class="paramname">className</td><td>Class name that was used to load the widget </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classtgui_1_1BaseTheme.html#a33384e4f4f47b8110e7d487049a41405">tgui::BaseTheme</a>.</p>

</div>
</div>
<a class="anchor" id="af1d7c0bd769f542fdcbf133f7358ea93"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classtgui_1_1WidgetConverter.html">WidgetConverter</a> tgui::Theme::internalLoad </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>className</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This function can be used inside a widget to load other widgets without access to the derived theme class. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>The filename that has to match the one used to load this theme </td></tr>
    <tr><td class="paramname">className</td><td>The class name of the theme to load </td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="classtgui_1_1BaseTheme.html#a57595e4c45be4574b70d006fb2acf3b3">tgui::BaseTheme</a>.</p>

</div>
</div>
<a class="anchor" id="a4f5d1531280273b1914f0f043b8dc75c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classtgui_1_1WidgetConverter.html">WidgetConverter</a> tgui::Theme::load </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>className</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Load the widget from the theme. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">className</td><td>Name of the class inside the theme file (equals widget type when no class is given)</td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classtgui_1_1Exception.html">Exception</a></td><td>when the requested class name could not be loaded from the file </td></tr>
    <tr><td class="paramname"><a class="el" href="classtgui_1_1Exception.html">Exception</a></td><td>when there was no loader for this type of widget </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a22dbce626a48780b9bddf239ae8fe834"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void tgui::Theme::reload </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Reload the theme with a different filename. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>Filename of the new theme file</td></tr>
  </table>
  </dd>
</dl>
<p>All widgets that are connected to this theme will be reloaded with the new theme file. The class names thus have to match with those from the old theme file!</p>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classtgui_1_1Exception.html">Exception</a></td><td>when one of the widgets failed to reload </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae45b316e7187975f24a02dac7753bc04"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void tgui::Theme::reload </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>oldClassName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>newClassName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Reload all widgets that were loaded with a certain class name. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">oldClassName</td><td>Class name that was used to load the widget </td></tr>
    <tr><td class="paramname">newClassName</td><td>Class name to load the widget with</td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classtgui_1_1Exception.html">Exception</a></td><td>when the requested new class name could not be loaded from the file </td></tr>
    <tr><td class="paramname"><a class="el" href="classtgui_1_1Exception.html">Exception</a></td><td>when one of the widgets failed to reload </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ace3e827ca1d7fe9bb28867dd18601f6b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void tgui::Theme::reload </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a>&#160;</td>
          <td class="paramname"><em>widget</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>className</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Reload a specific widget. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">widget</td><td>The widget to reload </td></tr>
    <tr><td class="paramname">className</td><td>Class name to load the widget with</td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classtgui_1_1Exception.html">Exception</a></td><td>when the requested class name could not be loaded from the file </td></tr>
    <tr><td class="paramname"><a class="el" href="classtgui_1_1Exception.html">Exception</a></td><td>when the widget failed to reload </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a77809152ae5a4b6adad307b43afd10ac"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void tgui::Theme::setProperty </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>className</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>property</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Change a property of the renderer of all widgets that were loaded with a certain class name. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">className</td><td>The class name of the widgets </td></tr>
    <tr><td class="paramname">property</td><td>The property that you would like to change </td></tr>
    <tr><td class="paramname">value</td><td>The new serialized value that you like to assign to the property</td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classtgui_1_1Exception.html">Exception</a></td><td>when deserialization fails or when the widget does not have this property. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a909fb7903bcf81bdd6730fabadcd521a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void tgui::Theme::setProperty </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>className</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>property</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classtgui_1_1ObjectConverter.html">ObjectConverter</a> &amp;&amp;&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Change a property of the renderer of all widgets that were loaded with a certain class name. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">className</td><td>The class name of the widgets </td></tr>
    <tr><td class="paramname">property</td><td>The property that you would like to change </td></tr>
    <tr><td class="paramname">value</td><td>The new value that you like to assign to the property. The <a class="el" href="classtgui_1_1ObjectConverter.html" title="Implicit converter for settable properties. ">ObjectConverter</a> is implicitly constructed from the possible value types.</td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classtgui_1_1Exception.html">Exception</a></td><td>for unknown properties or when value was of a wrong type. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a002af61e6bf83f0bbe6b849bcb5f4224"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void tgui::Theme::widgetDetached </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classtgui_1_1Widget.html">Widget</a> *&#160;</td>
          <td class="paramname"><em>widget</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function that gets called when a widget is disconnected from this theme. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">widget</td><td>The widget that was detached from this theme </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="classtgui_1_1BaseTheme.html#abb0553ae4e04d07db72923080e9be98d">tgui::BaseTheme</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>include/TGUI/Loading/<a class="el" href="Theme_8hpp_source.html">Theme.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- HTML footer for doxygen 1.8.10-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Nov 25 2017 17:32:45 for TGUI by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.11
</small></address>
<!-- BEGIN CUSTOM 3 -->
<!-- {% endraw %} -{{""}}-{{""}}>
</div>
{% include page_footer.ext %}
</div>
{% include footer.ext %}
<{{""}}!{{""}}-{{""}}- -->
<!-- END CUSTOM 3 -->
</body>
</html>
